package de.effigenix.application.masterdata;

import de.effigenix.domain.masterdata.*;
import de.effigenix.shared.common.Result;
import de.effigenix.shared.security.ActorId;
import org.springframework.transaction.annotation.Transactional;

import static de.effigenix.shared.common.Result.*;

@Transactional
public class ActivateCustomer {

    private final CustomerRepository customerRepository;

    public ActivateCustomer(CustomerRepository customerRepository) {
        this.customerRepository = customerRepository;
    }

    public Result<CustomerError, Customer> execute(CustomerId customerId, ActorId performedBy) {
        Customer customer;
        switch (customerRepository.findById(customerId)) {
            case Failure(var err) ->
                { return Result.failure(new CustomerError.RepositoryFailure(err.message())); }
            case Success(var opt) -> {
                if (opt.isEmpty()) {
                    return Result.failure(new CustomerError.CustomerNotFound(customerId));
                }
                customer = opt.get();
            }
        }
        customer.activate();

        switch (customerRepository.save(customer)) {
            case Failure(var err) ->
                { return Result.failure(new CustomerError.RepositoryFailure(err.message())); }
            case Success(var ignored) -> { }
        }

        return Result.success(customer);
    }
}
